PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Types | Public Member Functions | Protected Attributes | List of all members
PSafeWorkArg3< PtrClass, Arg1Type, Arg2Type, Arg3Type, FuncRet > Class Template Reference

A PSafeWork thread pool item where call back has 3 arguments. More...

`#include <threadpool.h>`

Inheritance diagram for PSafeWorkArg3< PtrClass, Arg1Type, Arg2Type, Arg3Type, FuncRet >:
[legend]
Collaboration diagram for PSafeWorkArg3< PtrClass, Arg1Type, Arg2Type, Arg3Type, FuncRet >:
[legend]

## Public Types
typedef FuncRet(PtrClass::* | Function )(Arg1Type arg1, Arg2Type arg2, Arg3Type arg3)

## Public Member Functions
| PSafeWorkArg3 (PtrClass *ptr, Arg1Type arg1, Arg2Type arg2, Arg2Type arg3, Function function)
virtual void | CallFunction (PSafeObject &obj)
Public Member Functions inherited from PSafeWork
| PSafeWork (PSafeObject *ptr)
virtual void | Work ()
Public Member Functions inherited from PSafePtrBase
virtual void | Assign (const PSafePtrBase &ptr)
virtual void | Assign (const PSafeCollection &safeCollection)
virtual void | Assign (PSafeObject *obj)
virtual void | Assign (PINDEX idx)
virtual Comparison | Compare (const PObject &obj) const
| Compare the pointers. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | SetNULL ()
| Set the pointer to NULL, unlocking/dereferencing existing pointer value. More...
bool | operator! () const
| Return true if pointer is NULL. More...
PSafeObject * | GetObject () const
| Return pointer to safe object. More...
template<class T >
T * | GetObjectAs () const
| Return pointer to safe object. More...
PSafetyMode | GetSafetyMode () const
| Get the locking mode used by this pointer. More...
virtual PBoolean | SetSafetyMode (PSafetyMode mode)
| Change the locking mode used by this pointer. More...
| ~PSafePtrBase ()
| Unlock and dereference the PSafeObject this is pointing to. More...
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Attributes
Function | m_function
Arg1Type | m_arg1
Arg2Type | m_arg2
Arg3Type | m_arg3

## Additional Inherited Members
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static __inline const PObject * | PTraceObjectInstance (const char *)
static __inline const PObject * | PTraceObjectInstance (const PObject *obj)
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Protected Types inherited from PSafePtrBase
enum | EnterSafetyModeOption { WithReference, AlreadyReferenced }
enum | ExitSafetyModeOption { WithDereference, NoDereference }
Protected Member Functions inherited from PSafePtrBase
virtual void | Next ()
virtual void | Previous ()
virtual void | DeleteObject (PSafeObject *obj)
PBoolean | EnterSafetyMode (EnterSafetyModeOption ref)
void | ExitSafetyMode (ExitSafetyModeOption ref)
virtual void | LockPtr ()
virtual void | UnlockPtr ()
| PSafePtrBase (PSafeObject *obj=NULL, PSafetyMode mode=PSafeReference)
| Create a new pointer to a PSafeObject. More...
| PSafePtrBase (const PSafeCollection &safeCollection, PSafetyMode mode, PINDEX idx)
| Create a new pointer to a PSafeObject. More...
| PSafePtrBase (const PSafeCollection &safeCollection, PSafetyMode mode, PSafeObject *obj)
| Create a new pointer to a PSafeObject. More...
| PSafePtrBase (const PSafePtrBase &enumerator)
| Copy the pointer to the PSafeObject. More...
Friends inherited from PObject

## Detailed Description

### template<class PtrClass, typename Arg1Type, typename Arg2Type, typename Arg3Type, typename FuncRet = void>
class PSafeWorkArg3< PtrClass, Arg1Type, Arg2Type, Arg3Type, FuncRet >

A PSafeWork thread pool item where call back has 3 arguments.

## Member Typedef Documentation

template<class PtrClass , typename Arg1Type , typename Arg2Type , typename Arg3Type , typename FuncRet = void>

typedef FuncRet(PtrClass::* PSafeWorkArg3< PtrClass, Arg1Type, Arg2Type, Arg3Type, FuncRet >::Function)(Arg1Type arg1, Arg2Type arg2, Arg3Type arg3)

## Constructor & Destructor Documentation

template<class PtrClass , typename Arg1Type , typename Arg2Type , typename Arg3Type , typename FuncRet = void>

PSafeWorkArg3< PtrClass, Arg1Type, Arg2Type, Arg3Type, FuncRet >::PSafeWorkArg3 | ( | PtrClass * | ptr,
|  | Arg1Type | arg1,
|  | Arg2Type | arg2,
|  | Arg2Type | arg3,
|  | Function | function
| ) |  |
| inline

## Member Function Documentation

template<class PtrClass , typename Arg1Type , typename Arg2Type , typename Arg3Type , typename FuncRet = void>

virtual void PSafeWorkArg3< PtrClass, Arg1Type, Arg2Type, Arg3Type, FuncRet >::CallFunction | ( | PSafeObject & | obj | ) |
| inline virtual

Implements PSafeWork.

References PSafeWorkArg3< PtrClass, Arg1Type, Arg2Type, Arg3Type, FuncRet >::m_arg1, PSafeWorkArg3< PtrClass, Arg1Type, Arg2Type, Arg3Type, FuncRet >::m_arg2, PSafeWorkArg3< PtrClass, Arg1Type, Arg2Type, Arg3Type, FuncRet >::m_arg3, and PSafeWorkArg3< PtrClass, Arg1Type, Arg2Type, Arg3Type, FuncRet >::m_function.

## Member Data Documentation

template<class PtrClass , typename Arg1Type , typename Arg2Type , typename Arg3Type , typename FuncRet = void>

Arg1Type PSafeWorkArg3< PtrClass, Arg1Type, Arg2Type, Arg3Type, FuncRet >::m_arg1
| protected

Referenced by PSafeWorkArg3< PtrClass, Arg1Type, Arg2Type, Arg3Type, FuncRet >::CallFunction().

template<class PtrClass , typename Arg1Type , typename Arg2Type , typename Arg3Type , typename FuncRet = void>

Arg2Type PSafeWorkArg3< PtrClass, Arg1Type, Arg2Type, Arg3Type, FuncRet >::m_arg2
| protected

Referenced by PSafeWorkArg3< PtrClass, Arg1Type, Arg2Type, Arg3Type, FuncRet >::CallFunction().

template<class PtrClass , typename Arg1Type , typename Arg2Type , typename Arg3Type , typename FuncRet = void>

Arg3Type PSafeWorkArg3< PtrClass, Arg1Type, Arg2Type, Arg3Type, FuncRet >::m_arg3
| protected

Referenced by PSafeWorkArg3< PtrClass, Arg1Type, Arg2Type, Arg3Type, FuncRet >::CallFunction().

template<class PtrClass , typename Arg1Type , typename Arg2Type , typename Arg3Type , typename FuncRet = void>

Function PSafeWorkArg3< PtrClass, Arg1Type, Arg2Type, Arg3Type, FuncRet >::m_function
| protected

Referenced by PSafeWorkArg3< PtrClass, Arg1Type, Arg2Type, Arg3Type, FuncRet >::CallFunction().

The documentation for this class was generated from the following file:

- threadpool.h